<?php
/*
SMF Gallery Lite Edition
Version 3.0
by:vbgamer45
http://www.smfhacks.com
Copyright 2008-2011 SMFHacks.com

############################################
License Information:
SMF Gallery is NOT free software.
This software may not be redistributed.

Links to http://www.smfhacks.com must remain unless
branding free option is purchased.
#############################################
*/
//Install the Database tables for SMF Gallery

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
  require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
  die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');


//Picture Table
$smcFunc['db_query']('', "CREATE TABLE IF NOT EXISTS {db_prefix}gallery_pic(
id_picture int(11) NOT NULL auto_increment,
id_member mediumint(8) unsigned NOT NULL default '0',
date int(10) unsigned NOT NULL default '0',
title varchar(100) NOT NULL,
description text,
 views int(10) NOT NULL default '0',
 filesize int(10) NOT NULL default '0',
 height int(10) NOT NULL default '0',
 width int(10) NOT NULL default '0',
 filename tinytext,
 thumbfilename tinytext,
 commenttotal int(10) NOT NULL default '0',
 id_cat int(10) NOT NULL default '0',
 approved tinyint(4) NOT NULL default '0',
 allowcomments tinyint(4) NOT NULL default '0',
 keywords varchar(100),
PRIMARY KEY  (id_picture))");


//Picture comments
$smcFunc['db_query']('', "CREATE TABLE IF NOT EXISTS {db_prefix}gallery_comment(
id_comment int(11) NOT NULL auto_increment,
id_picture int(11) NOT NULL,
id_member mediumint(8) unsigned NOT NULL default '0',
approved tinyint(4) NOT NULL default '0',
comment text,
date int(10) unsigned NOT NULL default '0',
PRIMARY KEY  (id_comment))");

//Gallery Category
$smcFunc['db_query']('', "CREATE TABLE IF NOT EXISTS {db_prefix}gallery_cat
(id_cat mediumint(8) NOT NULL auto_increment,
title varchar(100) NOT NULL,
description varchar(255) NOT NULL,
roworder mediumint(8) unsigned NOT NULL default '0',
image varchar(255) NOT NULL,
PRIMARY KEY  (id_cat))");


//Gallery Reported Images
$smcFunc['db_query']('', "CREATE TABLE IF NOT EXISTS {db_prefix}gallery_report
(id int(11) NOT NULL auto_increment,
id_picture int(11) NOT NULL,
id_member mediumint(8) unsigned NOT NULL default '0',
comment text,
date int(10) unsigned NOT NULL default '0',
PRIMARY KEY  (id))");

// Insert the settings
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_max_height', '2500')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_max_width', '2500')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_max_filesize', '5000000')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_who_viewing', '0')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_commentchoice', '0')");

$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_shop_picadd', '0')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_shop_commentadd', '0')");


$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_set_showcode_bbc_image', '0')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_set_showcode_directlink', '0')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_set_showcode_htmllink', '0')");


$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_set_images_per_page', '20')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_set_images_per_row','4')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_thumb_width', '120')");
$smcFunc['db_query']('', "INSERT IGNORE INTO {db_prefix}settings VALUES ('gallery_thumb_height', '78')");



// Add Package Servers
$smcFunc['db_query']('', "DELETE FROM {db_prefix}package_servers WHERE url = 'http://www.smfhacks.com'");
$smcFunc['db_query']('', "REPLACE INTO {db_prefix}package_servers (name,url) VALUES ('SMFHacks.com Modification Site', 'http://www.smfhacks.com')");


// If pretty Urls exist
if (file_exists($sourcedir . '/Subs-PrettyUrls.php'))
{
	// The following is based on Pretty Url's Extra's Mod by Dannii
	
	require_once($sourcedir . '/Subs-PrettyUrls.php');
	
	//	Add these filters
	$prettyFilters = unserialize($modSettings['pretty_filters']);
	
	//	Pretty URLs for SMF Gallery Lite
	$prettyFilters['smf-gallery-lite'] = array(
		'description' => 'Rewrite SMF Gallery URLs',
		'enabled' => 0,
		'filter' => array(
			'priority' => 30,
			'callback' => 'pretty_smf_gallery_lite_filter',
		),
		'rewrite' => array(
			'priority' => 30,
			'rule' => array(
				'RewriteRule ^gallery/index\.php$ index.php?action=gallery [L,QSA]',
				'RewriteRule ^gallery/category/([^/]+)/?$ ./index.php?action=gallery;cat=$1 [L,QSA]',
				'RewriteRule ^gallery/picture/([^/]+)/?$ ./index.php?action=gallery;sa=view;id=$1 [L,QSA]',
			),
		),
		'title' => 'SMF Gallery Lite',
	);
	
	updateSettings(array('pretty_filters' => isset($smcFunc) ? serialize($prettyFilters) : addslashes(serialize($prettyFilters))));
	
	//	Update everything now
	if (function_exists('pretty_update_filters'))
	pretty_update_filters();
}


// Permissions array
$permissions = array(
	'smfgallery_view' => array(-1, 0, 2), // ALL
);

addPermissions($permissions);

function addPermissions($permissions)
{
	global $smcFunc;

	$perm = array();

	foreach ($permissions as $permission => $default)
	{
		$result = $smcFunc['db_query']('', '
			SELECT COUNT(*)
			FROM {db_prefix}permissions
			WHERE permission = {string:permission}',
			array(
				'permission' => $permission
			)
		);

		list ($num) = $smcFunc['db_fetch_row']($result);

		if ($num == 0)
		{
			foreach ($default as $grp)
				$perm[] = array($grp, $permission);
		}
	}

	if (empty($perm))
		return;

	$smcFunc['db_insert']('insert',
		'{db_prefix}permissions',
		array(
			'id_group' => 'int',
			'permission' => 'string'
		),
		$perm,
		array()
	);
}

?>